from .paggf_layers import LoadedLayers
from .old_version_compatibility import geom_as_wkt

from qgis.core import qgsfunction

import uuid

@qgsfunction(args=0, group="Custom")
def get_selected_parcel_to_valid(value, feature, parent):
    layer = LoadedLayers().get("gis", "parcels_to_valid")
    s = layer.selectedFeatures()
    if len(s) == 1:
        return s[0]["id"]
    return None

@qgsfunction(args=0, group="Custom")
def get_selected_idc_parcel_to_valid(value, feature, parent):
    layer = LoadedLayers().get("gis", "idc_parcels_to_valid")
    s = layer.selectedFeatures()
    if len(s) == 1:
        return s[0]["id"]
    return None

@qgsfunction(args=0, group="Custom")
def gen_uuid(value, feature, parent):
    "Generates a uuid from a hash of the geometry"
    return str(uuid.uuid5(uuid.NAMESPACE_URL, geom_as_wkt(feature.geometry())))
