# Class with generic code for qgs layout
from qgis.core import QgsProject, QgsLayout, QgsReadWriteContext
from PyQt5.QtXml import QDomDocument
import os.path


def load_from_template(
        plugin_template_filename, # dans repertoire PAGGF/layout
        substitution_map=dict()
    ):
        global layout

        template_path = os.path.join(
            os.path.dirname(__file__), plugin_template_filename)

        template = QDomDocument()
        with open(template_path, encoding="utf-8") as template_file:
            data = template_file.read()

            for k in substitution_map:
                data = data.replace('[' + k + ']', substitution_map[k])
            template.setContent(data)
        template_file.close()

        layout = QgsLayout(QgsProject.instance())

        rw_context = QgsReadWriteContext()

        layout_items = layout.loadFromTemplate(
            template, rw_context)

        return layout
